    Program f07jefe

!     F07JEF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: dpttrf, dpttrs, nag_wp, x04caf
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Integer                          :: i, ifail, info, ldb, n, nrhs
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable  :: b(:,:), d(:), e(:)
!     .. Executable Statements ..
      Write (nout,*) 'F07JEF Example Program Results'
      Write (nout,*)
      Flush (nout)
!     Skip heading in data file
      Read (nin,*)
      Read (nin,*) n, nrhs
      ldb = n
      Allocate (b(ldb,nrhs),d(n),e(n-1))

!     Read the upper bidiagonal part of the tridiagonal matrix A from
!     data file

      Read (nin,*) e(1:n-1)
      Read (nin,*) d(1:n)

!     Read the right hand matrix B

      Read (nin,*)(b(i,1:nrhs),i=1,n)

!     Factorize the tridiagonal matrix A
!     The NAG name equivalent of dpttrf is f07jdf
      Call dpttrf(n,d,e,info)

      If (info==0) Then

!       Solve the equations AX = B
!       The NAG name equivalent of dpttrs is f07jef
        Call dpttrs(n,nrhs,d,e,b,ldb,info)

!       Print the solution

!       ifail: behaviour on error exit
!              =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
        ifail = 0
        Call x04caf('General',' ',n,nrhs,b,ldb,'Solution(s)',ifail)

      Else
        Write (nout,99999) 'The leading minor of order ', info, &
          ' is not positive definite'
      End If

99999 Format (1X,A,I3,A)
    End Program f07jefe
